---
title: TreeWalker
slug: Web/API/TreeWalker
tags:
  - API
  - DOM
---
<div>
<p>{{ APIRef("DOM") }}</p>
</div>

<p>The <strong><code>TreeWalker</code></strong> object represents the nodes of a document subtree and a position within them.</p>

<p>A <code>TreeWalker</code> can be created using the {{domxref("Document.createTreeWalker()")}} method.</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface doesn't inherit any property.</em></p>

<dl>
 <dt>{{domxref("TreeWalker.root")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Node")}} representing the root node as specified when the <code>TreeWalker</code> was created.</dd>
 <dt>{{domxref("TreeWalker.whatToShow")}} {{readonlyInline}}</dt>
 <dd>Returns an <code>unsigned long</code> being a bitmask made of constants describing the types of {{domxref("Node")}} that must be presented. Non-matching nodes are skipped, but their children may be included, if relevant. The possible values are:
 <table class="standard-table">
  <thead>
   <tr>
    <th class="header" scope="col">Constant</th>
    <th class="header" scope="col">Numerical value</th>
    <th class="header" scope="col">Description</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td><code>NodeFilter.SHOW_ALL</code></td>
    <td><code>-1</code> (that is the max value of <code>unsigned long</code>)</td>
    <td>Shows all nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_ATTRIBUTE</code> {{deprecated_inline}}</td>
    <td><code>2</code></td>
    <td>Shows attribute {{ domxref("Attr") }} nodes. This is meaningful only when creating a {{ domxref("TreeWalker") }} with an {{ domxref("Attr") }} node as its root. In this case, it means that the attribute node will appear in the first position of the iteration or traversal. Since attributes are never children of other nodes, they do not appear when traversing over the document tree.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_CDATA_SECTION</code> {{deprecated_inline}}</td>
    <td><code>8</code></td>
    <td>Shows {{ domxref("CDATASection") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_COMMENT</code></td>
    <td><code>128</code></td>
    <td>Shows {{ domxref("Comment") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_DOCUMENT</code></td>
    <td><code>256</code></td>
    <td>Shows {{ domxref("Document") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_DOCUMENT_FRAGMENT</code></td>
    <td><code>1024</code></td>
    <td>Shows {{ domxref("DocumentFragment") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_DOCUMENT_TYPE</code></td>
    <td><code>512</code></td>
    <td>Shows {{ domxref("DocumentType") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_ELEMENT</code></td>
    <td><code>1</code></td>
    <td>Shows {{ domxref("Element") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_ENTITY</code> {{deprecated_inline}}</td>
    <td><code>32</code></td>
    <td>Shows {{ domxref("Entity") }} nodes. This is meaningful only when creating a {{ domxref("TreeWalker") }} with an {{ domxref("Entity") }} node as its root; in this case, it means that the {{ domxref("Entity") }} node will appear in the first position of the traversal. Since entities are not part of the document tree, they do not appear when traversing over the document tree.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_ENTITY_REFERENCE</code> {{deprecated_inline}}</td>
    <td><code>16</code></td>
    <td>Shows {{ domxref("EntityReference") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_NOTATION</code> {{deprecated_inline}}</td>
    <td><code>2048</code></td>
    <td>Shows {{ domxref("Notation") }} nodes. This is meaningful only when creating a {{ domxref("TreeWalker") }} with a {{ domxref("Notation") }} node as its root; in this case, it means that the {{ domxref("Notation") }} node will appear in the first position of the traversal. Since entities are not part of the document tree, they do not appear when traversing over the document tree.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_PROCESSING_INSTRUCTION</code></td>
    <td><code>64</code></td>
    <td>Shows {{ domxref("ProcessingInstruction") }} nodes.</td>
   </tr>
   <tr>
    <td><code>NodeFilter.SHOW_TEXT</code></td>
    <td><code>4</code></td>
    <td>Shows {{ domxref("Text") }} nodes.</td>
   </tr>
  </tbody>
 </table>
 </dd>
 <dt>{{domxref("TreeWalker.filter")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("NodeFilter")}} used to select the relevant nodes.</dd>
 <dt>{{domxref("TreeWalker.expandEntityReferences")}} {{readonlyInline}}{{obsolete_inline}}</dt>
 <dd>Is a {{domxref("Boolean")}} indicating, when discarding an {{domxref("EntityReference")}} its whole sub-tree must be discarded at the same time.</dd>
 <dt>{{domxref("TreeWalker.currentNode")}}</dt>
 <dd>Is the {{domxref("Node")}} on which the <code>TreeWalker</code> is currently pointing at.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface doesn't inherit any method.</em></p>

<div class="note">
<p><strong>Note</strong>: in the context of a <code>TreeWalker</code>, a node is <em>visible</em> if it exists in the logical view determined by the <code>whatToShow</code> and <code>filter</code> parameter arguments. (Whether or not the node is visible on the screen is irrelevant.)</p>
</div>

<dl>
 <dt>{{domxref("TreeWalker.parentNode()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to the first <em>visible</em> ancestor node in the document order, and returns the found node. It also moves the current node to this one. If no such node exists, or if it is before that the <em>root</em><em> node</em> defined at the object construction, returns <code>null</code> and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.firstChild()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to the first <em>visible</em> child of the current node, and returns the found child. It also moves the current node to this child. If no such child exists, returns <code>null</code> and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.lastChild()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to the last <em>visible</em> child of the current node, and returns the found child. It also moves the current node to this child. If no such child exists, <code>null</code> is returned and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.previousSibling()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to its previous sibling, if any, and returns the found sibling. If there is no such node, return <code>null</code> and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.nextSibling()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to its next sibling, if any, and returns the found sibling. If there is no such node, <code>null</code> is returned and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.previousNode()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to the previous <em>visible</em> node in the document order, and returns the found node. It also moves the current node to this one. If no such node exists, or if it is before that the <em>root</em><em> node</em> defined at the object construction, returns <code>null</code> and the current node is not changed.</dd>
 <dt>{{domxref("TreeWalker.nextNode()")}}</dt>
 <dd>Moves the current {{domxref("Node")}} to the next <em>visible</em> node in the document order, and returns the found node. It also moves the current node to this one. If no such node exists, returns <code>null</code> and the current node is not changed.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#interface-treewalker', 'TreeWalker')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Removed the <code>expandEntityReferences</code> property.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'traversal.html#Traversal-TreeWalker', 'TreeWalker')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TreeWalker")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The creator method: {{domxref("Document.createTreeWalker()")}}.</li>
 <li>Related interfaces: {{domxref("NodeFilter")}}, {{domxref("NodeIterator")}}.</li>
</ul>
